﻿Partial Class Form1

    ' ==============================================================================================================
    '   COMMANDS
    ' ==============================================================================================================
    Private Sub btn_GcodeRun_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeRun.ClickButtonArea
        If btn_GcodeStep.Checked Then Return
        StartStopRunningState()
        CNC_SingleStep = False
        btn_GcodeStep.Checked = False
        SKIN_UpdateButtons_Form1()
    End Sub
    Private Sub btn_GcodePause_ClickButtonArea(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_GcodePause.ClickButtonArea
        If btn_GcodeStep.Checked Then Return
        If btn_GcodeRun.Checked Then
            StartStopRunningState()
            btn_GcodePause.Checked = True
        Else
            btn_GcodePause.Checked = False
        End If
        btn_GcodePause.Refresh()
        CNC_SingleStep = False
        btn_GcodeStep.Checked = False
        SKIN_UpdateButtons_Form1()
    End Sub
    Private Sub btn_GcodeStop_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GCodeStop.ClickButtonArea
        btn_GCodeStop.Text = "STOP"
        CNC_SingleStep = False
        btn_GcodeStep.Checked = False
        CNC_GcodeRunning = True
        StopRunningState("")
        StopCalibrations()
        SKIN_UpdateButtons_Form1()
    End Sub
    Private Sub btn_GcodeStep_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeStep.ClickButtonArea
        StartSingleStep()
    End Sub
    Private Sub btn_GcodeRewind_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeRewind.ClickButtonArea
        RewindGcode()
    End Sub

    Friend Sub RewindGcode()
        If Not btn_GcodeRewind.Enabled Then Return
        SKIN_UpdateButtons_Form1()
        btn_GCodeStop.Text = "STOP"
        btn_GcodeRewind.Refresh()
        CNC_LineInExecution = 0
        CNC_LineToBeExecuted = 0
        UpdateUserInterfaceInfo()
        UserInterfaceRedraw_Disable()
        RTB.SelectionLength = 1
        CNC_Dest = CNC_Tip
        CNC_SetFeedMode(Feed_Modes.None)
        btn_GcodeRewind.Checked = False
        Pic_Toolpath.Focus()
        GraphicThread_DrawToolpathImage(False)
        ResetGcodeTime()
        SKIN_UpdateButtons_Form1()
    End Sub

    Friend Sub StartSingleStep()
        If CNC_SingleStep Then Return
        If btn_GcodeRun.Checked Then
            StartStopRunningState()
            btn_GcodeStep.Checked = False
            btn_GcodeStep.Refresh()
        Else
            CNC_SingleStep = True
            btn_GcodeStep.Checked = True
            btn_GcodeStep.Refresh()
            StartStopRunningState()
            ShowCoords()
            Me.Refresh()
        End If
    End Sub

    Friend Sub StartStopRunningState()
        '
        CNC_WaitingTemperature = False
        '
        If CNC_GcodeRunning Then
            btn_GcodeRun.Checked = True
            btn_GcodePause.Checked = True
            StartPauseState()
            Return
        End If
        If GCodeParsedLines.Length = 0 Then
            btn_GcodeRun.Checked = False
            SKIN_UpdateButtons_Form1()
            Return
        End If
        If GC_UsedZ AndAlso CNC_TestLowZ AndAlso _
           CNC_Tip.z < CNC_WarningZeta AndAlso Not btn_GcodePause.Checked Then
            If Form_MsgBox.Message_YesNo("WARNING: Z is low" + _
                                         vbCr + "Do you really want to start?") <> "YES" Then
                btn_GcodeRun.Checked = False
                SKIN_UpdateButtons_Form1()
                Return
            End If
        End If
        ExecutionThread_Stop()
        CNC_ReadTemperatureTables()
        ExecutionThread_Start()
        Pic_Toolpath.Focus()
        btn_GCodeStop.Text = "STOP"
        btn_GCodeStop.Checked = False
        btn_GcodePause.Checked = False
        btn_GcodeRun.Checked = True
        RTB.ReadOnly = True
        RTB.ContextMenuStrip = Nothing
        EnableAllControls(False)
        CalibrationButtons_Disable()
        GraphicThread_DrawToolpathImage(False)
        GraphicThread_WaitToolpathImageCompletion()
        CNC_SetAccessoryEnableOutput(True)
        CNC_RestoreOutputSignals()
        CNC_EnsureZeroToDeltaSlots()
        CNC_EnsureSafeValuesToInputSlots()
        ' ----------------------------------------------- ensure zero to unsed axis
        If Not GC_UsedZ Then CNC_Dest.z = 0
        If Not GC_UsedA Then CNC_Dest.a = 0
        If Not GC_UsedB Then CNC_Dest.b = 0
        ' -----------------------------------------------
        CNC_SetFeedMode(GCodeParsedLines(CNC_LineInExecution).FeedMode)
        CNC_LookAhead_LastSegment.InitWithValue(0)
        CNC_GcodeRunning = True
        CNC_EnableTimedUpdateAndUserInterface()
        GcodeTime.Start()
        SKIN_UpdateButtons_Form1()
    End Sub

    Friend Sub StartPauseState()
        Pic_Toolpath.Focus()
        If Not btn_GcodeRun.Checked Then
            btn_GcodePause.Checked = False
            Return
        End If
        If btn_GcodePause.Checked Then
            RTB.ContextMenuStrip = CTX_Edit
            CNC_GcodeRunning = False
            CNC_TimedUpdateEnabled = False
            CNC_SetSpindleOnOff(0)
            GcodeTime.Stop()
            If CNC_LineInExecution > 0 Then
                CNC_LineInExecution -= 1
                CNC_LineToBeExecuted -= 1
            End If
        Else
            CNC_EnableTimedUpdateAndUserInterface()
            GraphicThread_DrawToolpathImage(False)
            CNC_RestoreOutputSignals()
            RTB.ContextMenuStrip = Nothing
            CNC_GcodeRunning = True
            GcodeTime.Start()
        End If
        ' ---------------------------------------- 
        btn_GcodeRun.Checked = False
        btn_GcodeRun.Refresh()
        SKIN_UpdateButtons_Form1()
        ' ---------------------------------------- wait motors really stopped
        While CNC_MaxDelta() > MaxDeltaValue
            SleepMyThread(10)
            Timer1_Tick(Nothing, Nothing)
            Pic_Toolpath.Refresh()
        End While
        UserInterfaceRedraw_Disable()
        ' ---------------------------------------- enable jog
        CNC_SetFeedMode(Feed_Modes.None)
        btn_GcodeStep.Enabled = True
        btn_GcodeRewind.Enabled = True
    End Sub

    Friend Sub StopRunningState(ByVal reason As String)

        If reason <> "" Then
            btn_GCodeStop.Text = "STOP (" + reason + ")"
            If reason = "end of program" Then
                RTB.ScrollToCaret()
                PlayStopSound()
            End If
        End If
        btn_GcodePause.Checked = False
        btn_GcodePause.Refresh()
        btn_GCodeStop.Checked = True
        btn_GCodeStop.Refresh()
        btn_GcodeStep.Checked = False
        btn_GcodeStep.Refresh()

        If CNC_FeedSpeedLockedType = CNC_FeedSpeedLockedTypes.AllLocked Or _
           CNC_FeedSpeedLockedType = CNC_FeedSpeedLockedTypes.SpeedLocked Then
            CNC_ResetSpindleOutputs(False)
        Else
            CNC_ResetSpindleOutputs(True)
        End If
        CNC_SetAccessoryEnableOutput(False)
        CNC_ResetCoolings()
        CNC_GcodeRunning = False
        CNC_SingleStep = False
        CNC_TimedUpdateEnabled = False
        CNC_CipExecution = False
        CNC_CipExecute = False
        CNC_Dest = CNC_Tip
        GcodeTime.Stop()
        ' ------------------------------------- wait motors really stopped
        While CNC_MaxDelta() > MaxDeltaValue
            SleepMyThread(10)
            Timer1_Tick(Nothing, Nothing)
            Pic_Toolpath.Refresh()
        End While
        CNC_SetFeedMode(Feed_Modes.None)
        UserInterfaceRedraw_Disable()
        ' ------------------------------------- 
        RTB.ReadOnly = False
        RTB.ContextMenuStrip = CTX_Edit
        btn_GcodeRun.Checked = False
        EnableAllControls(True)
        CalibrationButtons_Enable()
        CalibrationButtons_Uncheck()
        SKIN_UpdateButtons_Form1()
        UpdateUserInterfaceInfo()
        ' this overrides the "Max Err" effects (but it is better to see them)
        'GraphicThread_DrawToolpathImage(True)
        Pic_Toolpath.Focus()
    End Sub
    Friend Sub ResetGcodeTime()
        GcodeTime.Reset()
        ShowGcodeTime()
    End Sub
    Private Sub EnableAllControls(ByVal enable As Boolean)
        btn_InOutEnabled.Enabled = enable
        btn_HalEnabled.Enabled = enable
        Menu_File.Enabled = enable
        Menu_Tools.Enabled = enable
        Menu_Options.Enabled = enable
        Menu_Skins.Enabled = enable
        Menu_3DPrinters.Enabled = enable
        ToolStripButton_LoadGcode.Enabled = enable
        ToolStripButton_SaveGcode.Enabled = enable
        ToolStripButton_SaveGcodeAs.Enabled = enable
        'btn_SingleStep.Enabled = enable
        btn_GcodeRewind.Enabled = enable
        btn_Up.Enabled = enable
        btn_Down.Enabled = enable
        btn_GotoZero.Enabled = enable
        btn_GotoHome.Enabled = enable
        btn_GotoBottomLeft.Enabled = enable
        btn_GotoTopRight.Enabled = enable
        btn_ZeroX.Enabled = enable
        btn_ZeroY.Enabled = enable
        btn_ZeroZ.Enabled = enable
        btn_ZeroA.Enabled = enable
        btn_ZeroB.Enabled = enable
    End Sub

    Private Sub DisableAll(ByVal reason As String) ' M84
        CNC_SetMainEnableOutput(False)
        btn_InOutEnabled.Checked = False
    End Sub

    Friend Sub PlayStopSound()
        My.Computer.Audio.Stop()
        Dim fname As String = Application.StartupPath + "\Sounds"
        Select Case Form_Options.StopSoundType
            Case Form_Options.StopSoundTypes.NoSound : fname = ""
            Case Form_Options.StopSoundTypes.Sound1 : fname += "\StopSound1.wav"
            Case Form_Options.StopSoundTypes.Sound2 : fname += "\StopSound2.wav"
            Case Form_Options.StopSoundTypes.Sound3 : fname += "\StopSound3.wav"
            Case Form_Options.StopSoundTypes.Sound4 : fname += "\StopSound4.wav"
            Case Form_Options.StopSoundTypes.Sound5 : fname += "\StopSound5.wav"
        End Select
        If IO.File.Exists(fname) Then
            Try
                My.Computer.Audio.Play(fname, AudioPlayMode.Background)
            Catch
            End Try
        End If
    End Sub

    ' ==================================================================================================
    '   CROSS THREAD FUNCTIONS
    ' ==================================================================================================
    Friend Delegate Sub DisableAllCrossThread_Delegate(ByVal reason As String)
    Friend Sub DisableAllCrossThread(ByVal reason As String)
        If InvokeRequired Then
            BeginInvoke(New DisableAllCrossThread_Delegate(AddressOf DisableAll), reason)
        Else
            DisableAll(reason)
        End If
    End Sub

    Friend Delegate Sub StopRunningStateCrossThread_Delegate(ByVal reason As String)
    Friend Sub StopRunningStateCrossThread(ByVal reason As String)
        If InvokeRequired Then
            BeginInvoke(New StopRunningStateCrossThread_Delegate(AddressOf StopRunningStateCrossThread), reason)
        Else
            StopRunningState(reason)
        End If
    End Sub

    Friend Delegate Sub StopAndWait_RunningStateCrossThread_Delegate(ByVal reason As String)
    Friend Sub StopAndWait_RunningStateCrossThread(ByVal reason As String)
        If InvokeRequired Then
            Invoke(New StopAndWait_RunningStateCrossThread_Delegate(AddressOf StopAndWait_RunningStateCrossThread), reason)
        Else
            StopRunningState(reason)
            'StartPauseState()
        End If
    End Sub


    Friend Delegate Sub SimpleMessageCrossThread_Delegate(ByVal text As String)
    Friend Sub SimpleMessageCrossThread(ByVal text As String)
        If InvokeRequired Then
            BeginInvoke(New SimpleMessageCrossThread_Delegate(AddressOf SimpleMessageCrossThread), text)
        Else
            Form_MsgBox.SimpleMessage(text)
        End If
    End Sub

    Friend Delegate Sub MessageCrossThread_Delegate(ByVal text As String)
    Friend Sub MessageCrossThread(ByVal text As String)
        If InvokeRequired Then
            BeginInvoke(New MessageCrossThread_Delegate(AddressOf MessageCrossThread), text)
        Else
            Form_MsgBox.Message_OK(text, , 16)
        End If
    End Sub

    Friend Delegate Sub MessageCrossThread_Waiting_Delegate(ByVal text As String)
    Friend Sub MessageCrossThread_Waiting(ByVal text As String)
        If InvokeRequired Then
            Invoke(New MessageCrossThread_Waiting_Delegate(AddressOf MessageCrossThread_Waiting), text)
        Else
            Form_MsgBox.Message_OK(text, , 16)
        End If
    End Sub



    Friend Delegate Sub CalibrateZfromG92_Waiting_Delegate(ByVal command As String)
    Friend Sub CalibrateZfromG92_Waiting(ByVal command As String)
        If InvokeRequired Then
            Invoke(New CalibrateZfromG92_Waiting_Delegate(AddressOf CalibrateZfromG92_Waiting), command)
        Else
            Select Case command
                Case "StartCalibration"
                    ' ----------------------------------------------------- Click the CalibrateZ button
                    btn_CalibrateZ.Checked = True
                    btn_CalibrateZ_ClickButtonArea(Nothing, Nothing)
                Case "RestartProgram"
                    ' ----------------------------------------------------- Click the RUN button
                    'btn_GCodeStop.Checked = True
                    'btn_GcodeStop_ClickButtonArea(Nothing, Nothing)
                    'StopCalibrations()
                    btn_GcodeRun.Checked = True
                    btn_GcodeRun_ClickButtonArea(Nothing, Nothing)
            End Select
        End If
    End Sub

End Class
