﻿Public Class Form_Options

    Private Sub Me_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If e.CloseReason = CloseReason.UserClosing Then
            Me.Hide()
            e.Cancel = True
        End If
    End Sub


    ' ==============================================================================================================
    '   Params 
    ' ==============================================================================================================
    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles _
                                                                            txt_FirstSlot.LostFocus, _
                                                                            txt_FirstTextSlot.LostFocus, _
                                                                            txt_JogSpeedShift.LostFocus, _
                                                                            txt_JogSpeedNormal.LostFocus, _
                                                                            txt_SpindleDelay.LostFocus, _
                                                                            txt_HalMaxSpeed.LostFocus, _
                                                                            txt_HalMaxAcc.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub Params_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
                                                                            txt_FirstSlot.TextChanged, _
                                                                            txt_FirstTextSlot.TextChanged, _
                                                                            txt_JogSpeedShift.TextChanged, _
                                                                            txt_JogSpeedNormal.TextChanged, _
                                                                            txt_SpindleDelay.TextChanged, _
                                                                            txt_HalMaxSpeed.TextChanged, _
                                                                            txt_HalMaxAcc.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        SetAllParams()
        EventsAreEnabled = True
    End Sub

    Friend Sub SetAllParams()
        CNC_SetSlots(txt_FirstSlot.NumericValueInteger)
        Form1.SetTextSlots(txt_FirstTextSlot.NumericValueInteger)
        CNC_JogSpeedShift = txt_JogSpeedShift.NumericValueInteger
        CNC_JogSpeedNormal = txt_JogSpeedNormal.NumericValueInteger
        CNC_SpindleDelay = txt_SpindleDelay.NumericValue
        CNC_HalMaxSpeed = txt_HalMaxSpeed.NumericValueInteger
        CNC_HalMaxAcc = txt_HalMaxAcc.NumericValueInteger
        ShowRealTipPosition = btn_ShowRealTipPosition.Checked
        CompensateAcceleration = btn_CompensateAcceleration.Checked
        LimitMaxSpeed()
        EventsAreEnabled = False
        Form1.SetAllParams()
        EventsAreEnabled = True
    End Sub

    Friend Sub LimitMaxSpeed()
        If Form1.txt_Rapid.NumericValueInteger > CNC_HalMaxSpeed Then
            Form1.txt_Rapid.NumericValueInteger = CNC_HalMaxSpeed
        End If
        If Form1.txt_Feed.NumericValueInteger > CNC_HalMaxSpeed Then
            Form1.txt_Feed.NumericValueInteger = CNC_HalMaxSpeed
        End If
        Form1.txt_Rapid.MaxValue = CNC_HalMaxSpeed
        Form1.txt_Feed.MaxValue = CNC_HalMaxSpeed
    End Sub

    ' ==============================================================================================================
    '   HAL TYPE
    ' ==============================================================================================================
    Friend Enum HalTypes
        HAL
        IOT_HAL
    End Enum
    Friend HalType As HalTypes = HalTypes.HAL

    Private Sub btn_HalType_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles btn_HalType.ClickButtonArea
        '
        Form1.StopThereminoHAL()
        HalType = CType((HalType + 1) Mod 2, HalTypes)
        UpdateHalTypeButton()
        SKIN_UpdateButtons_FormOptions()
        Form1.StartThereminoHAL()
    End Sub
    Friend Sub UpdateHalTypeButton()
        Select Case HalType
            Case HalTypes.HAL
                btn_HalType.Text = "HAL"
                btn_HalType.Checked = False
            Case HalTypes.IOT_HAL
                btn_HalType.Text = "IOT HAL"
                btn_HalType.Checked = True
        End Select
    End Sub

    ' ==============================================================================================================
    '   DELAY TYPE
    ' ==============================================================================================================
    Friend Enum DelayTypes
        BeforeWorkSections
        AfterMcodes
    End Enum
    Friend DelayType As DelayTypes = DelayTypes.BeforeWorkSections

    Private Sub btn_DelayType_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles btn_DelayType.ClickButtonArea
        '
        DelayType = CType((DelayType + 1) Mod 2, DelayTypes)
        UpdateDelayTypeButton()
        SKIN_UpdateButtons_FormOptions()
    End Sub
    Friend Sub UpdateDelayTypeButton()
        Select Case DelayType
            Case DelayTypes.BeforeWorkSections
                btn_DelayType.Text = "Before work sections"
                btn_DelayType.Checked = False
                CNC_DelayBeforeWorkSections = True
            Case DelayTypes.AfterMcodes
                btn_DelayType.Text = "After M03 M04 M13 M14"
                btn_DelayType.Checked = True
                CNC_DelayBeforeWorkSections = False
        End Select
    End Sub

    ' ==============================================================================================================
    '   MOVEMENT TYPE
    ' ==============================================================================================================
    Friend Enum MovementTypes
        NormalMovement
        CoreXY
    End Enum
    Friend MovementType As MovementTypes = MovementTypes.NormalMovement

    Private Sub btn_MovementType_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles btn_MovementType.ClickButtonArea
        '
        MovementType = CType((MovementType + 1) Mod 2, MovementTypes)
        UpdateMovementTypeButton()
        SKIN_UpdateButtons_FormOptions()
    End Sub
    Friend Sub UpdateMovementTypeButton()
        Select Case MovementType
            Case MovementTypes.NormalMovement
                btn_MovementType.Text = "Normal movement"
                btn_MovementType.Checked = False
                CNC_CoreXY = False
            Case MovementTypes.CoreXY
                btn_MovementType.Text = "CoreXY with motors A - B"
                btn_MovementType.Checked = True
                CNC_CoreXY = True
        End Select
    End Sub

    ' ==============================================================================================================
    '   STOP SOUND 
    ' ==============================================================================================================
    Friend Enum StopSoundTypes
        NoSound
        Sound1
        Sound2
        Sound3
        Sound4
        Sound5
    End Enum
    Friend StopSoundType As StopSoundTypes = StopSoundTypes.NoSound

    Private Sub btn_StopSound_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                             Handles btn_StopSound.ClickButtonArea
        '
        StopSoundType = CType((StopSoundType + 1) Mod 6, StopSoundTypes)
        UpdateStopSoundButton()
        Form1.PlayStopSound()
        SKIN_UpdateButtons_FormOptions()
    End Sub
    Friend Sub UpdateStopSoundButton()
        Select Case StopSoundType
            Case StopSoundTypes.NoSound
                btn_StopSound.Text = "No Sound"
                btn_StopSound.Checked = False
            Case StopSoundTypes.Sound1
                btn_StopSound.Text = "Sound 1"
                btn_StopSound.Checked = True
            Case StopSoundTypes.Sound2
                btn_StopSound.Text = "Sound 2"
                btn_StopSound.Checked = True
            Case StopSoundTypes.Sound3
                btn_StopSound.Text = "Sound 3"
                btn_StopSound.Checked = True
            Case StopSoundTypes.Sound4
                btn_StopSound.Text = "Sound 4"
                btn_StopSound.Checked = True
            Case StopSoundTypes.Sound5
                btn_StopSound.Text = "Sound 5"
                btn_StopSound.Checked = True
        End Select
    End Sub

    Private Sub btn_ShowRealTipPosition_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShowRealTipPosition.ClickButtonArea
        SetAllParams()
        Save_INI()
        SKIN_UpdateButtons_FormOptions()
    End Sub

    Private Sub btn_CompensateAcceleration_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_CompensateAcceleration.ClickButtonArea
        SetAllParams()
        Save_INI()
        SKIN_UpdateButtons_FormOptions()
    End Sub

End Class